<?php

namespace Ardent\PipelineBundle\Pipeline\OptionsProcessor;

use Psr\Log\LoggerInterface;
use Symfony\Contracts\Service\Attribute\Required;

abstract class AbstractOptionsStage implements OptionsStageInterface
{
    protected Options $options;

    protected LoggerInterface $logger;

    public function setOptions(Options $options): void
    {
        $this->options = $options;
    }

    #[Required]
    public function setLogger(LoggerInterface $logger): void
    {
        $this->logger = $logger;
    }

    public function before(ItemCollection $items): void
    {
        $this->logger->notice(sprintf('Begin %s with %d item(s)', static::class, $items->count()));
    }

    public function after(ItemCollection $items): void
    {
        $this->logger->notice(sprintf('End %s with %d item(s)', static::class, $items->count()));
    }
}