<?php

namespace Ardent\PipelineBundle\Pipeline\OptionsProcessor;

class ItemCollection
{
    /**
     * @var Item[]
     */
    private array $items = [];

    public function count(): int
    {
        return count($this->items);
    }

    public function add(Item $item): self
    {
        $this->items[$item->getId()] = $item;

        return $this;
    }

    public function remove(Item $item): self
    {
        if ($this->has($item)) {
            unset($this->items[$item->getId()]);
        }

        return $this;
    }

    public function has(Item $item): bool
    {
        return array_key_exists($item->getId(), $this->items);
    }

    /**
     * @return Item[]
     */
    public function all(): array
    {
        return $this->items;
    }
}