<?php

namespace Ardent\PipelineBundle\Pipeline\OptionsProcessor;

use Psr\Container\ContainerInterface;
use Symfony\Component\DependencyInjection\Attribute\TaggedLocator;
use Symfony\Component\DependencyInjection\ServiceLocator;

class OptionsStageBag implements ContainerInterface
{
    private readonly ServiceLocator $locator;

    public function __construct(
        #[TaggedLocator(OptionsStageInterface::class, indexAttribute: 'name')]
        ServiceLocator $locator
    )
    {
        $this->locator = $locator;
    }

    /**
     * @template T of OptionsStageInterface
     *
     * @param class-string<T> $id
     *
     * @return T
     * @throws \Symfony\Component\DependencyInjection\Exception\ServiceNotFoundException
     */
    public function get(string $id): OptionsStageInterface
    {
        return $this->locator->get($id);
    }

    public function has(string $id): bool
    {
        return $this->locator->has($id);
    }
}